
class CDebugNastaveni : public CDialog
{
	CToolTipCtrl m_oNapoveda;
public:
// Construction
	CDebugNastaveni(CWnd* pParent = NULL);   // standard constructor
  ~CDebugNastaveni(void);

// Dialog Data
	//{{AFX_DATA(CDebugNastaveni)
	enum { IDD = IDD_DEBUGNASTAVENI };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDebugNastaveni)
	protected:
    virtual BOOL PreTranslateMessage(MSG* pMsg);
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CDebugNastaveni)
	afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
	virtual BOOL OnInitDialog();
	virtual void OnOK();
	afx_msg void OnClose();
	afx_msg void BublinkovaNapoveda();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


CDebugNastaveni::CDebugNastaveni(CWnd* pParent /*=NULL*/)
	: CDialog(CDebugNastaveni::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDebugNastaveni)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CDebugNastaveni::~CDebugNastaveni(void) {
  if (IsWindow(m_hWnd)) DestroyWindow();
 }

void CDebugNastaveni::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDebugNastaveni)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDebugNastaveni, CDialog)
	//{{AFX_MSG_MAP(CDebugNastaveni)
	ON_WM_HELPINFO()
	ON_COMMAND(ID_ZKRATKA_SMAZRADEK, OnClose)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDebugNastaveni message handlers

BOOL CDebugNastaveni::OnHelpInfo(HELPINFO* pHelpInfo) {
	return(TRUE);
 }

BOOL CDebugNastaveni::OnInitDialog() {
char *hlaska=NULL,*docasne=NULL,*docasnahlaska=NULL;
CEdit* pEdit;

  CDialog::OnInitDialog();

  hlaska=ALOKUJ_RETEZEC(5000);
  docasnahlaska=ALOKUJ_RETEZEC(5000);
  docasne=ALOKUJ_RETEZEC(200);

  switch(g_nastaveni.nalada) {
    case 1: strcpy(docasne,"vborn"); break;
    case 2: strcpy(docasne,"dobr"); break;
    case 3: strcpy(docasne,"normln"); break;
    case 4: strcpy(docasne,"patn"); break;
    case 5: strcpy(docasne,"hrozn"); break;
    default: strcpy(docasne,"CHYBN SLO!"); break;
   }

  sprintf(hlaska,""
  "-------------------------------  PAM̍  ------------------------------\r\n"
  "   Poet alokovanch blok: %lu\r\n"
  "   Minimln poet slov: %lu\r\n"
  "--------------------------  UIVATELSK  ------------------------\r\n"
  "   Aktuln nlada potae: %d (%s)\r\n"
  "   Posledn odpov potae:\r\n %s\r\n"
  "   Poet alternativ odpovd: %lu\r\n"
  "   Posledn vta lovka: %s\r\n",
    debug_pocetalokovani,debug_maxpocetvsechslov,
    g_nastaveni.naladabody,docasne,g_odpovedpocitace,
    g_pocetodpovedipocitace,g_predchozivetacloveka);

  strcpy(docasne,debug_poslednipodmetcloveka);
  ODUPRAV_SLOVO_PRO_IQPOKYD(docasne);
  sprintf(docasnahlaska,"     Podmt: %s\r\n",docasne);
  strcat(hlaska,docasnahlaska);

  strcpy(docasne,debug_posledniprisudekcloveka);
  ODUPRAV_SLOVO_PRO_IQPOKYD(docasne);
  sprintf(docasnahlaska,"     Psudek: %s\r\n",docasne);
  strcat(hlaska,docasnahlaska);

  strcpy(docasne,debug_poslednipredmetcloveka);
  ODUPRAV_SLOVO_PRO_IQPOKYD(docasne);
  sprintf(docasnahlaska,"     Pedmt: %s\r\n",docasne);
  strcat(hlaska,docasnahlaska);

  sprintf(docasnahlaska,
  "----------------------------  SLOVNKY  ----------------------------\r\n"
  "   Slov v \"zkladn\" databzi: %lu\r\n"
  "   Podmnek databze odpovd: %lu",
    g_pocetslovvzakladnidatabazi,
    g_pocetiqpodminek);
  strcat(hlaska,docasnahlaska);

  if (g_nastaveni.zobrazovatpopisky == 0)  //npovda pi vypnutch popiscch
   strcat(hlaska,"\r\n\r\nPozn.: Pokud chce npovdu k jednotlivm polokm vpravo, povol v \"normlnm\" nastaven zobrazovn popisk funkc.");

  pEdit = (CEdit*)GetDlgItem(IDC_HODNOTY);
  pEdit->SetWindowText(hlaska);


  sprintf(hlaska,"%d",g_nastaveni.naladabody);
  pEdit = (CEdit*)GetDlgItem(IDC_NALADABODY);
  pEdit->SetWindowText(hlaska);

  UVOLNI(docasne);
  UVOLNI(docasnahlaska);
  UVOLNI(hlaska);

  CheckDlgButton(IDC_RYCHLEUKONCOVANI,g_nastaveni.debug_rychleukoncovani);

  switch(g_nastaveni.debug_tolerancepravopisu) {
    case 0: CheckDlgButton(IDC_ZADNATOLERANCEPRAVOPISU,1); break;
    case 1: CheckDlgButton(IDC_UPLNATOLERANCEPRAVOPISU,1); break;
    default: NAHLAS_CHYBU(__FILE__,__LINE__,_NESPECIFIKOVANO_,_UKONCIT_);
   }
  switch(g_nastaveni.debug_pravopisnarekurze) {
    case 0: CheckDlgButton(IDC_ZADNAREKURZEPROHLEDAVANI,1); break;
    case 7: CheckDlgButton(IDC_MALAREKURZEPROHLEDAVANI,1); break;
    case 11: CheckDlgButton(IDC_STREDNIREKURZEPROHLEDAVANI,1); break;
    case 15: CheckDlgButton(IDC_VELKAREKURZEPROHLEDAVANI,1); break;
    case 100: CheckDlgButton(IDC_MAXIMALNIREKURZEPROHLEDAVANI,1); break;
    default: NAHLAS_CHYBU(__FILE__,__LINE__,_NESPECIFIKOVANO_,_UKONCIT_);
   }


  m_oNapoveda.Create(this);
  if (g_nastaveni.zobrazovatpopisky == 1) m_oNapoveda.Activate(TRUE);
  else m_oNapoveda.Activate(FALSE);
  m_oNapoveda.SendMessage(TTM_SETMAXTIPWIDTH,0,450);
  m_oNapoveda.SendMessage(TTM_SETDELAYTIME,TTDT_AUTOPOP,20000);
  m_oNapoveda.SendMessage(TTM_SETDELAYTIME,TTDT_INITIAL,200);
  m_oNapoveda.SendMessage(TTM_SETDELAYTIME,TTDT_RESHOW,0);

  BublinkovaNapoveda();
  
  return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
 }

BOOL CDebugNastaveni::PreTranslateMessage(MSG* pMsg) {
  m_oNapoveda.RelayEvent(pMsg);
  return CDialog::PreTranslateMessage(pMsg);
 }

void CDebugNastaveni::OnOK() {
BYTE noveukoncovani,novatolerance,novarekurze,novanaladabody,ulozeni=0;
WORD pozice;
char *naladabodyedit=ALOKUJ_RETEZEC(11);
CString koncovkapohlavi;
CEdit *pEdit;

  if (g_nastaveni.pohlavicloveka == 2) koncovkapohlavi='';
  else koncovkapohlavi='';

  pEdit = (CEdit*)GetDlgItem(IDC_NALADABODY);
  pEdit->GetWindowText(naladabodyedit,10); naladabodyedit[10]=0;
  novanaladabody=0;
  for (pozice=0; pozice < strlen(naladabodyedit); pozice++) {
    if (naladabodyedit[pozice] < '0' || naladabodyedit[pozice] > '9') {
      MessageBox("Pesn nlada mus bt cel kladn slo!","Chyba",MB_ICONWARNING | MB_SYSTEMMODAL);
      pEdit->SetFocus(); UVOLNI(naladabodyedit); return;
     }
    if (novanaladabody > 25) goto MIMOROZSAH;
  // 25*10 + treba 9 je 259 a to je vetsi nez 255 a o dost vetsi nex maximalnich 90

    novanaladabody*=10;
    novanaladabody+=naladabodyedit[pozice]-'0';
   }
  if (novanaladabody > 90) {
MIMOROZSAH:
    MessageBox("Pesn nlada mus bt slo v rozmez 0 - 90!","Chyba",MB_ICONWARNING | MB_SYSTEMMODAL);
    pEdit->SetFocus(); UVOLNI(naladabodyedit); return;
   }
  UVOLNI(naladabodyedit);

  if (IsDlgButtonChecked(IDC_RYCHLEUKONCOVANI) != 0) noveukoncovani=1;
  else noveukoncovani=0;

  if (IsDlgButtonChecked(IDC_ZADNATOLERANCEPRAVOPISU) != 0) novatolerance=0;
  if (IsDlgButtonChecked(IDC_UPLNATOLERANCEPRAVOPISU) != 0) novatolerance=1;

  if (IsDlgButtonChecked(IDC_ZADNAREKURZEPROHLEDAVANI) != 0) novarekurze=0;
  if (IsDlgButtonChecked(IDC_MALAREKURZEPROHLEDAVANI) != 0) novarekurze=7;
  if (IsDlgButtonChecked(IDC_STREDNIREKURZEPROHLEDAVANI) != 0) novarekurze=11;
  if (IsDlgButtonChecked(IDC_VELKAREKURZEPROHLEDAVANI) != 0) novarekurze=15;
  if (IsDlgButtonChecked(IDC_MAXIMALNIREKURZEPROHLEDAVANI) != 0) novarekurze=100;

  if (g_nastaveni.debug_rychleukoncovani != noveukoncovani
   || g_nastaveni.debug_tolerancepravopisu != novatolerance
   || g_nastaveni.debug_pravopisnarekurze != novarekurze) { //pokud je zmena

    if (MessageBox("Zmna nastaven me mt nechtn nsledky.\nJsi si jist"+koncovkapohlavi+", e chce nov parametry uloit?","Upozornn",MB_OKCANCEL | MB_ICONWARNING | MB_SYSTEMMODAL) != IDOK) return;

    g_nastaveni.debug_rychleukoncovani=noveukoncovani;
    g_nastaveni.debug_tolerancepravopisu=novatolerance;
    g_nastaveni.debug_pravopisnarekurze=novarekurze;
    ulozeni=1;
   }
  if (g_nastaveni.naladabody != novanaladabody) {
    g_nastaveni.naladabody=novanaladabody;
    g_nastaveni.SPOCITEJ_NALADU_PODLE_NALADABODY();
    ZAPIS_DO_MENU_AKTUALNI_STAV_NASTAVENI();
    ulozeni=1;
   }

  if (ulozeni == 1) ZAPIS_NASTAVENI_DO_SOUBORU(g_nastaveni);


  CDialog::OnOK();
 }

void CDebugNastaveni::OnClose() {
  SendMessage(WM_CLOSE);
 }

void CDebugNastaveni::BublinkovaNapoveda() {
CString koncovkapohlavi;
  if (g_nastaveni.pohlavicloveka == 2) koncovkapohlavi='';
  else koncovkapohlavi='';

  m_oNapoveda.AddTool(GetDlgItem(IDC_HODNOTY),"Zde jsou napsan rzn stavov promnn programu (platn v okamiku sputn tohoto dialogu).");
  m_oNapoveda.AddTool(GetDlgItem(IDC_NALADABODY),"slo, kter udv, jakou mm te momentln nladu. Toto slo me bt v rozmez 0 - 90. Jednotliv \"viditeln\" nlady jsou potom tyto:\n0 - 29 - vborn\n30 - 44 - dobr\n45 - 59 - normln\n60 - 74 - patn\n75 - 90 - hrozn\nToto slo se neukld, ukld se pouze \"viditeln\" nlada a toto slo se potom pi sputn piblin vypot z n.\nPokud toto slo te zmn, me se tm samozejm zmnit i ona \"viditeln\" nlada.");
  m_oNapoveda.AddTool(GetDlgItem(IDC_RYCHLEUKONCOVANI),"Udv, m-li se program ukonovat bez uvolovn pamti. Tu by ml uvolnit i samotn operan systm, ale na nkterch starch systmech tm dochz k niku pamti. Pokud podstoup riziko, e se me pam \"zahlcovat\", rychl ukonovn si me dovolit.\r\n<STANDARDN:  NE>");
  m_oNapoveda.AddTool(GetDlgItem(IDC_ZADNATOLERANCEPRAVOPISU),"Nastavovat dnou toleranci pravopisu se nedoporuuje, jsi-li si vak jist"+koncovkapohlavi+", e pravopis zvld, zpesn to detekci vty a v konenm dsledku i zkvalitn rozhovor.");
  m_oNapoveda.AddTool(GetDlgItem(IDC_UPLNATOLERANCEPRAVOPISU),"<STANDARDN>\npln tolerance pravopisu znamen, e dv pravopisn patnm slovm (tm) stejnou vhu jako sprvnm. Nap.: \"cizinec\" m stejnou vhu jako \"cyzinec\", nezvisle na tom, e u druhho slova se mus zmnit 1 hlska, aby slovo mlo smysl.\nVt \"citlivost\" v detekci pravopisu bude zahrnuta v ptch verzch.");
  m_oNapoveda.AddTool(GetDlgItem(IDC_ZADNAREKURZEPROHLEDAVANI),"Pokud nastav dnou rekurzi, nebudou se jednak prohledvat ppadn pravopisn chyby, ale tak se nebudou prohledvat slova, kter s pravopisem nesouvis!\nNapklad \"staiv\" a \"statyv\". Nedoporuuje se.");
  m_oNapoveda.AddTool(GetDlgItem(IDC_MALAREKURZEPROHLEDAVANI),"Zde se prohledv jen do 7 rekurz na 1 slovo. Velice rychl a vtinou to sta. (Pozor, pokud \"nevyzbude\" rekurze, nevyzbude na konci slova!)");
  m_oNapoveda.AddTool(GetDlgItem(IDC_STREDNIREKURZEPROHLEDAVANI),"<STANDARDN>\nZde se prohledv do 11 rekurz na 1 slovo. Rychl a opravdu dostaujc.");
  m_oNapoveda.AddTool(GetDlgItem(IDC_VELKAREKURZEPROHLEDAVANI),"Zde se prohledv a do 15 rekurz na 1 slovo. Me bt pomal.");
  m_oNapoveda.AddTool(GetDlgItem(IDC_MAXIMALNIREKURZEPROHLEDAVANI),"Zde nen dn limit. Slovo se prohled vdy cel. Program vak me v krajnch ppadech \"zamrznout\" (zkus si napsat slovo \"yyyyyyyyyyyyyyyyyyyy\").");
  m_oNapoveda.AddTool(GetDlgItem(IDOK),"Zavt toto okno a uloit (i do souboru) ppadn zmny v nastaven.");
  m_oNapoveda.AddTool(GetDlgItem(IDCANCEL),"Zavt toto okno bez ukldn nastaven.");
 }
